WinStd Additional templates and function helpers for Microsoft Windows using Standard C++ classes

Public Member Functions | Protected Member Functions | List of all members
winstd::eap_packet Class Reference
Extensible Authentication Protocol API

EapPacket wrapper class. More...

`#include <EAP.h>`

Inheritance diagram for winstd::eap_packet:

## Public Member Functions
virtual | ~eap_packet ()
| Destroys the EAP packet.
bool | create (_In_ EapCode code, _In_ BYTE id, _In_ WORD size) noexcept
| Create new EAP packet. More...
WORD | size () const noexcept
| Returns total EAP packet size in bytes.
Public Member Functions inherited from winstd::dplhandle< EapPacket *, NULL >
| dplhandle () noexcept
| Initializes a new class instance with the object handle set to INVAL.
| dplhandle (_In_opt_ handle_type h) noexcept
| Initializes a new class instance with an already available object handle. More...
| dplhandle (_In_ const dplhandle< handle_type, INVAL > &h) noexcept
| Copy constructor. More...
| dplhandle (_Inout_ dplhandle< handle_type, INVAL > &&h) noexcept
| Move constructor. More...
dplhandle< handle_type, INVAL > & | operator= (_In_opt_ handle_type h) noexcept
| Attaches already available object handle. More...
dplhandle< handle_type, INVAL > & | operator= (_In_ const dplhandle< handle_type, INVAL > &h) noexcept
| Duplicates the object. More...
dplhandle< handle_type, INVAL > & | operator= (_Inout_ dplhandle< handle_type, INVAL > &&h) noexcept
| Moves the object. More...
handle_type | duplicate () const
| Duplicates and returns a new object handle. More...
bool | attach_duplicated (_In_opt_ handle_type h)
| Duplicates an object handle and sets a new object handle. More...
Public Member Functions inherited from winstd::handle< EapPacket *, INVAL >
| handle () noexcept
| Initializes a new class instance with the object handle set to INVAL.
| handle (_In_opt_ handle_type h) noexcept
| Initializes a new class instance with an already available object handle. More...
| handle (_Inout_ handle< handle_type, INVAL > &&h) noexcept
| Move constructor. More...
handle< handle_type, INVAL > & | operator= (_In_opt_ handle_type h) noexcept
| Attaches already available object handle. More...
handle< handle_type, INVAL > & | operator= (_Inout_ handle< handle_type, INVAL > &&h) noexcept
| Move assignment. More...
| operator handle_type () const
| Auto-typecasting operator. More...
handle_type *& | operator* () const
| Returns the object handle value when the object handle is a pointer to a value (class, struct, etc.). More...
handle_type * | operator& ()
| Returns the object handle reference. More...
handle_type | operator-> () const
| Provides object handle member access when the object handle is a pointer to a class or struct. More...
bool | operator! () const
| Tests if the object handle is INVAL. More...
bool | operator< (_In_opt_ handle_type h) const
| Is handle less than? More...
bool | operator<= (_In_opt_ handle_type h) const
| Is handle less than or equal to? More...
bool | operator>= (_In_opt_ handle_type h) const
| Is handle greater than or equal to? More...
bool | operator> (_In_opt_ handle_type h) const
| Is handle greater than? More...
bool | operator!= (_In_opt_ handle_type h) const
| Is handle not equal to? More...
bool | operator== (_In_opt_ handle_type h) const
| Is handle equal to? More...
void | attach (_In_opt_ handle_type h) noexcept
| Sets a new object handle for the class. More...
handle_type | detach ()
| Dismisses the object handle from this class. More...
void | free ()
| Destroys the object.

## Protected Member Functions
void | free_internal () noexcept override
| Destroys the EAP packet. More...
handle_type | duplicate_internal (_In_ handle_type h) const noexcept override
| Duplicates the EAP packet. More...
virtual handle_type | duplicate_internal (_In_ handle_type h) const noexcept=0
| Abstract member function that must be implemented by child classes to do the actual object handle duplication. More...
virtual void | free_internal () noexcept=0
| Abstract member function that must be implemented by child classes to do the actual object destruction. More...

## Additional Inherited Members
Public Types inherited from winstd::handle< EapPacket *, INVAL >
typedef EapPacket * | handle_type
| Datatype of the object handle this template class handles.
Static Public Attributes inherited from winstd::handle< EapPacket *, INVAL >
static const EapPacket * | invalid
| Invalid handle value.
Protected Attributes inherited from winstd::handle< EapPacket *, INVAL >
handle_type | m_h
| Object handle.

## Detailed Description

EapPacket wrapper class.

## Member Function Documentation

## ◆ create()

bool winstd::eap_packet::create | ( | _In_ EapCode | code,
|  | _In_ BYTE | id,
|  | _In_ WORD | size
| ) |  |
| inline noexcept

Create new EAP packet.

Parameters

  [in] | code | EAP code (one of EapCode enum values)
  [in] | id | Packet ID
  [in] | size | Total packet size in bytes, including header. Must be at least 4B.

Note
  Packet data (beyond first 4B) is not initialized.

Returns
  - true when creation succeeds;
  - false when creation fails. For extended error information, call `GetLastError()`.

## ◆ duplicate_internal()

handle_type winstd::eap_packet::duplicate_internal | ( | _In_ handle_type | h | ) | const
| inline override protected virtual noexcept

Duplicates the EAP packet.

Implements winstd::dplhandle< EapPacket *, NULL >.

## ◆ free_internal()

void winstd::eap_packet::free_internal | ( |  | ) |
| inline override protected virtual noexcept

Destroys the EAP packet.

Implements winstd::handle< EapPacket *, INVAL >.

The documentation for this class was generated from the following file:

- include/WinStd/EAP.h